
#If Not %DEF(%IDE_FF)
    #INCLUDE Once "rtncodes.inc"
#EndIf


%RTFONT_DEFAULT         = 0
%RTFONT_ARIAL           = 0
%RTFONT_ABLACK          = 1 'Arial Black
%RTFONT_CONSOLAS        = 2
%RTFONT_COURIER         = 3 'Courier New
%RTFONT_LUCIDA          = 4 'Lucida Console

%RTFONTSIZE_DEFAULT     = 14

%RTColor_Default        = 0
%RTColor_Black          = 0
%RTColor_Red            = 1
%RTColor_Orange         = 2
%RTColor_Yellow         = 3
%RTColor_Green          = 4
%RTColor_Blue           = 5
%RTColor_Purple         = 6
%RTColor_Violet         = 6
%RTColor_Brown          = 7

%RTAlign_Left           = 0
%RTAlign_Center         = 1
%RTAlign_Right          = 2
%RTAlign_Justify        = 3



Type REDescriptor
    IsBold As Long
    IsItalic As Long
    MyFont As Dword
    MyFontSize As Dword
    MyColor As Dword
    MyLineSpacing As Single
    MySpacePad As Long
    MyAlign As Dword
End Type


Global gHndlRichEdit As Dword   'handle to the control
Global gsRELine As String       'the current line (aka "Paragraph")
Global gsREDoc As String
Global gLastDesc As REDescriptor
Global gdNumLines As Dword
Global glLineInit As Long
Global glRTInit As Long
Global gNeedPard As Long

FUNCTION SetSpaceAfter(MySpacePad As Long, Optional ByVal Force As Long) As String

    Dim sRes As String

    If glRTInit = %TRUE Then
        If MySpacePad = %TRUE Then
            sRes = "\sa200"
        Else
            sRes = ""
        End If
        gLastDesc.MySpacePad = MySpacePad
        gNeedPard = %TRUE
    Else
        If (MySpacePad <> gLastDesc.MySpacePad) Or (Force = %TRUE) Then
            If MySpacePad = %TRUE Then
                sRes = "\sa200"
            Else
                sRes = "\sa0"
            End If
            gLastDesc.MySpacePad = MySpacePad
            gNeedPard = %TRUE
        End If
    End If

    FUNCTION = sRes
End FUNCTION

FUNCTION SetLineSpacing(MyLineSpacing As Single, Optional ByVal Force As Long) As String

    Dim sSL As String
    Dim sRes As String

    sSL = Trim$(Str$(CDwd(240 * MyLineSpacing)))

    If (glRTInit = %TRUE) Or (Force = %TRUE) Then
        sRes = "\sl" & sSL & "\slmult1"
        gLastDesc.MyLineSpacing = MyLineSpacing
        gNeedPard = %TRUE
    Else
        If MyLineSpacing <> gLastDesc.MyLineSpacing Then
            sRes = "\sl" & sSL & "\slmult1"
            gLastDesc.MyLineSpacing = MyLineSpacing
            gNeedPard = %TRUE
        End If
    End If

    FUNCTION = sRes
End FUNCTION

FUNCTION SetAlignment(MyAlign As Dword) As String

    Dim sQ As String
    Dim sRes As String

    Select Case MyAlign
        Case %RTAlign_Left
            sQ = ""
        Case %RTAlign_Center
            sQ = "\qc"
        Case %RTAlign_Right
            sQ = "\qr"
        Case %RTAlign_Justify
            sQ = "\qj"
        Case Else
            sQ = ""
    End Select
    If MyAlign <> gLastDesc.MyAlign Then
        sRes = sQ
        gLastDesc.MyAlign = MyAlign
        gNeedPard = %TRUE
    Else
        sRes = ""
    End If

    FUNCTION = sRes
End FUNCTION

FUNCTION SetColor(MyColor As Dword) As String

    Dim sRes As String

    If glRTInit = %TRUE Then
        If %RTColor_Default <> MyColor Then
            sRes = "\cf" & Trim$(Str$(MyColor))
        Else
            sRes = ""
        End If
        gLastDesc.MyColor = MyColor
    Else
        If gLastDesc.MyColor <> MyColor Then
            sRes = "\cf" & Trim$(Str$(MyColor))
            gLastDesc.MyColor = MyColor
        Else
            sRes = ""
        End If
    End If

    FUNCTION = sRes
End FUNCTION

FUNCTION SetFontSize(MyFontSize As Dword) As String

    Dim sRes As String

    If glRTInit = %TRUE Then
        sRes = "\fs" & Trim$(Str$(MyFontSize * 2))
        gLastDesc.MyFontSize = MyFontSize
    Else
        If gLastDesc.MyFontSize <> MyFontSize Then
            sRes = "\fs" & Trim$(Str$(MyFontSize * 2))
            gLastDesc.MyFontSize = MyFontSize
        Else
            sRes = ""
        End If
    End If

    FUNCTION = sRes
End FUNCTION

FUNCTION SetFont(MyFont As Dword) As String

    Dim sRes As String

    If glRTInit = %TRUE Then
        If MyFont <> %RTFONT_DEFAULT Then
            sRes = "\f" & Trim$(Str$(MyFont))
            gLastDesc.MyFont = MyFont
        Else
            sRes = ""
        End If
    Else
        If MyFont <> gLastDesc.MyFont Then
            sRes = "\f" & Trim$(Str$(MyFont))
            gLastDesc.MyFont = MyFont
        Else
            sRes = ""
        End If
    End If

    FUNCTION = sRes
End FUNCTION

FUNCTION SetBold(IsBold As Long) As String

    Dim sRes As String

    If gLastDesc.IsBold <> IsBold Then
        If IsBold = %TRUE Then
            sRes = "\b"
        Else
            sRes = "\b0"
        End If
        gLastDesc.IsBold = IsBold
    Else
        sRes = ""
    End If

    FUNCTION = sRes
End FUNCTION

FUNCTION SetItalic(IsItalic As Long) As String

    Dim sRes As String

    If gLastDesc.IsItalic <> IsItalic Then
        If IsItalic = %TRUE Then
            sRes = "\ib"
        Else
            sRes = "\i0"
        End If
        gLastDesc.IsItalic = IsItalic
    Else
        sRes = ""
    End If

    FUNCTION = sRes
End FUNCTION

FUNCTION EscapeString(InString As String) As String

    Dim sRes As String

    sRes = InString

    Replace "\" With "\\" In sRes
    FUNCTION = sRes
End FUNCTION



Sub InitRichText(ByVal REHndl As Dword)

    Dim N As Dword
    Dim NMax As Dword

    gHndlRichEdit = REHndl
    gsRELine = ""
    gsREDoc = ""

    NMax = DataCount

    For N = 1 To NMax
        gsREDoc = gsREDoc & Read$(N)
        If (N < NMax) Then gsREDoc = gsREDoc & $CrLf
    Next N

    gdNumLines = 0
    glLineInit = %TRUE
    glRTInit = %TRUE

    Data "{\rtf1\ansi\ansicpg1252\deff0\deflang1033{\fonttbl{\f0\fnil\fcharset0 Arial;}{\f1\fnil\fcharset0 Arial Black;}{\f2\fnil\fcharset0 Consolas;}{\f3\fnil\fcharset0 Courier New;}{\f4\fnil\fcharset0 Lucida Console;}}"
    Data "{\colortbl ;\red255\green0\blue0;\red255\green192\blue0;\red255\green255\blue0;\red0\green176\blue80;\red0\green77\blue187;\red155\green0\blue211;\red128\green64\blue64;}"
    Data "{\*\generator Msftedit 5.41.21.2510;}\viewkind4\uc1"

End Sub

Sub ResetDescriptor(ByRef TextDesc As REDescriptor)

    TextDesc.IsBold = %FALSE
    TextDesc.IsItalic = %FALSE
    TextDesc.MyFont = %RTFONT_DEFAULT
    TextDesc.MyFontSize = %RTFONTSIZE_DEFAULT
    TextDesc.MyColor = %RTColor_Default
    TextDesc.MyLineSpacing = 1.0
    TextDesc.MySpacePad = %TRUE
    TextDesc.MyAlign = %RTAlign_Left

    gLastDesc = TextDesc

End Sub

Sub PrintToLine(LineRT As String, ByVal TextDesc As REDescriptor, Optional ByVal TabCount As Dword)

    Dim sAlign As String
    Dim sBuild As String
    Dim lForce As Long
    Dim N As Dword

    sBuild = ""

    If glLineInit = %TRUE Then
        sAlign = SetAlignment(TextDesc.MyAlign)
        If sAlign <> "" Then
            lForce = %TRUE
        Else
            lForce = %FALSE
        End If

        sBuild = SetSpaceAfter(TextDesc.MySpacePad, lForce)
        sBuild = sBuild & SetLineSpacing(TextDesc.MyLineSpacing, lForce)
        sBuild = sBuild & sAlign
    End If
    sBuild = sBuild & SetColor(TextDesc.MyColor)
    If glRTInit = %TRUE Then
        sBuild = sBuild & "\lang9"
    End If
    sBuild = sBuild & SetBold(TextDesc.IsBold)
    sBuild = sBuild & SetItalic(TextDesc.IsItalic)
    sBuild = sBuild & SetFont(TextDesc.MyFont)
    sBuild = sBuild & SetFontSize(TextDesc.MyFontSize)
    
    If TabCount > 0 Then
        For N = 1 To TabCount
            sBuild = sBuild & "\tab"
        Next N
    End If
    
    If LineRT <> "" Then sBuild = sBuild & " " & EscapeString(LineRT)

    If (gsRELine = "") And (((glLineInit = %TRUE) And (gNeedPard = %TRUE)) Or (glRTInit = %TRUE)) Then
        gsRELine = "\pard" & sBuild  'Suspicious of this
        gNeedPard = %FALSE
    Else
        gsRELine = gsRELine & sBuild
    End If

    glRTInit = %FALSE
    glLineInit = %FALSE

End Sub

Sub PrintTab(Optional ByVal TabCount As Dword)

    Dim N As Dword

    If TabCount > 0 Then
        For N = 1 To TabCount
            gsRELine = gsRELine & "\tab"
        Next N
    End If
End Sub

Sub CommitLine()

    gsRELine = gsRELine & "\par"

    If gdNumLines = 0 Then
        gsREDoc = gsREDoc & gsRELine
    Else
        gsREDoc = gsREDoc & $CrLf & gsRELine
    End If

    gsRELine = ""

    Incr gdNumLines
    glLineInit = %TRUE

End Sub

Sub BlankLine()

    If gdNumLines = 0 Then
        gsREDoc = gsREDoc & "\par"
    Else
        gsREDoc = gsREDoc & $CrLf & "\par"
    End If

    Incr gdNumLines
    glLineInit = %TRUE

End Sub

Sub CommitRT()

    Dim N As Dword
    Dim NMax As Dword

    gsREDoc = gsREDoc & $CrLf & "}" 

    #If %DEF( %USE_APP_RTF_FOCUS)  
        Call APP_SET_RTF_FOCUS
    #EndIf

    'push it to the control
    Call FF_RichEdit_SetText(gHndlRichEdit, gsREDoc, %FALSE)
    
    'Now Reset everything for the next screen
    gsRELine = ""
    gsREDoc = ""

    NMax = DataCount

    For N = 1 To NMax
        gsREDoc = gsREDoc & Read$(N)
        If (N < NMax) Then gsREDoc = gsREDoc & $CrLf
    Next N

    gdNumLines = 0
    glLineInit = %TRUE
    glRTInit = %TRUE

    Data "{\rtf1\ansi\ansicpg1252\deff0\deflang1033{\fonttbl{\f0\fnil\fcharset0 Arial;}{\f1\fnil\fcharset0 Arial Black;}{\f2\fnil\fcharset0 Consolas;}{\f3\fnil\fcharset0 Courier New;}{\f4\fnil\fcharset0 Lucida Console;}}"
    Data "{\colortbl ;\red255\green0\blue0;\red255\green192\blue0;\red255\green255\blue0;\red0\green176\blue80;\red0\green77\blue187;\red155\green0\blue211;\red128\green64\blue64;}"
    Data "{\*\generator Msftedit 5.41.21.2510;}\viewkind4\uc1"
    
End Sub
