'------------------------------------------------------------------------------
' Source code generated by FireFly Visual Designer Version: 3.70
' Generated: Monday  July 15, 2019 at 09:18:50 PM
' Visit www.planetsquires.com for more information
'------------------------------------------------------------------------------

Function FF_Control_GetCheck( ByVal hWndControl As Dword ) As Long
    
    ' Do a check to ensure that this is actually a window handle
    If IsWindow(hWndControl) Then  
       
       ' Get the check state
         If SendMessage( hWndControl, %BM_GETCHECK, 0, 0) = %BST_CHECKED Then
            Function = %TRUE
         End If   
       
    End If
       
End Function



Sub FF_Control_GetColor( ByVal hWndControl As Dword, _
                         ByRef ForeColor As Long, _
                         ByRef BackColor As Long)

    Local ff As FLY_DATA Ptr 
    Local hBrush As Dword
    Local LOG_BRUSH As LOGBRUSH
     
    ' Do a check to ensure that this is actually a window handle
    If IsWindow(hWndControl) Then  
       
       ff = GetProp(hWndControl, "FLY_PTR")
       
       If ff Then
          ' Determine is we are dealing with a Form or Control
          If @ff.IsForm Then             
             hBrush = GetClassLong( hWndControl, %GCL_HBRBACKGROUND) 
             'Get the Color From the brush:
             GetObject hBrush, SizeOf(LOG_BRUSH), ByVal VarPtr(LOG_BRUSH)
             ForeColor = 0
             BackColor = LOG_BRUSH.lbColor
             Exit Sub
          End If
          
          If @ff.ProcessCtlColor Then      
             If @ff.IsForeSysColor Then
                ForeColor = GetSysColor( @ff.nForeColor )
             Else
                ForeColor = @ff.nForeColor
             End If   
          
             If @ff.IsBackSysColor Then
                BackColor = GetSysColor( @ff.nBackColor )
             Else
                BackColor = @ff.nBackColor
             End If   

          Else
             ForeColor = GetSysColor( @ff.nForeColor )
             BackColor = GetSysColor( @ff.nBackColor )
          End If
             
       End If
       
    End If
End Sub



Function FF_Control_GetTag( ByVal hWndControl As Dword ) as String
                                   
   Local pzString As Asciiz Ptr
   
   'Get the pointer to the Tag string from the hWnd PROP.
   pzString = GetProp( hWndControl, "FLY_TAGPROPERTY" )
   
   If pzString = 0 Then
      'Null pointer
      Function = ""
   Else
      Function = @pzString
   End If      

End Function



Function FF_Control_GetTag2( ByVal hWndControl As Dword ) as String
                                   
   Local pzString As Asciiz Ptr
   
   'Get the pointer to the Tag2 string from the hWnd PROP.
   pzString = GetProp( hWndControl, "FLY_TAGPROPERTY2" )
   
   If pzString = 0 Then
      'Null pointer
      Function = ""
   Else
      Function = @pzString
   End If      

End Function



Function FF_Control_GetText(ByVal hWndControl As Dword) As String
    
    Local nBufferSize As Long
    Local nBuffer     As String
    
    ' Do a check to ensure that this is actually a window handle
    If IsWindow(hWndControl) Then
       
       ' Get the length of the text
         nBufferSize = GetWindowTextLength(hWndControl)
         If nBufferSize = 0 Then 
            Function = "": GoTo ExitOut
         End If                       
         
       ' Add an extra character for the Nul terminator
         Incr nBufferSize
         
       ' Create the temporary buffer
         nBuffer = Space$(nBufferSize)
         
       ' Retrieve the text
         GetWindowText hWndControl, ByVal StrPtr(nBuffer), nBufferSize

       ' Remove the Null
         nBuffer = RTrim$(nBuffer, $Nul)

         Function = nBuffer
         
    End If
    
ExitOut:
    
End Function



Sub FF_Control_Redraw( ByVal hWndControl As Dword )

    ' Do a check to ensure that this is actually a window handle
    If IsWindow(hWndControl) Then  
       
       ' Signal the Control to be redrawn.
       InvalidateRect hWndControl, ByVal %Null, %TRUE
       UpdateWindow hWndControl
         
    End If
End Sub



Sub FF_Control_SetCheck( ByVal hWndControl As Dword, _
                         ByVal nCheckState As Long ) 
    
    ' Do a check to ensure that this is actually a window handle
    If IsWindow(hWndControl) Then  
       
       ' Set the check state
         If nCheckState Then
            SendMessage hWndControl, %BM_SETCHECK, %BST_CHECKED, 0
         Else
            SendMessage hWndControl, %BM_SETCHECK, %BST_UNCHECKED, 0
         End If
            
    End If
       
End Sub



Sub FF_Control_SetColor( ByVal hWndControl As Dword, _
                         ByVal ForeColor As Long, _
                         ByVal BackColor As Long)

    Local ff_control  As FLY_DATA Ptr 
    Local Redraw_Flag As Long
    
    ' Do a check to ensure that this is actually a window handle
    If IsWindow(hWndControl) Then  
       
       ff_control = GetProp(hWndControl, "FLY_PTR")
       
       If ff_control Then
          
          ' Determine is we are dealing with a Form or Control
            If @ff_control.IsForm Then             
            
                ' ForeColor has no effect on a Form
                
                ' Set the Background color
                  If BackColor <> -1 Then
                     If @ff_control.hBackBrush Then Call DeleteObject(@ff_control.hBackBrush)
                     @ff_control.hBackBrush = CreateSolidBrush(BackColor) 
                     @ff_control.nBackColor = BackColor
                     @ff_control.IsBackSysColor = %FALSE
                     SetClassLong hWndControl, %GCL_HBRBACKGROUND, CreateSolidBrush(BackColor)
                     Redraw_Flag = %TRUE
                  End If   
            
            Else
            
                ' Set the Foreground color
                  If ForeColor <> -1 Then
                     @ff_control.nForeColor = ForeColor
                     @ff_control.IsForeSysColor = %FALSE
                     Redraw_Flag = %TRUE
                  End If   
                    
                ' Set the Background color
                  If BackColor <> -1 Then
                     If @ff_control.hBackBrush Then Call DeleteObject(@ff_control.hBackBrush)
                     @ff_control.hBackBrush = CreateSolidBrush(BackColor)
                     @ff_control.nBackColor = BackColor
                     @ff_control.IsBackSysColor = %FALSE
                     Redraw_Flag = %TRUE
                  End If
                  
           End If
           
           If Redraw_Flag Then
              InvalidateRect hWndControl, ByVal %Null, %TRUE
              UpdateWindow hWndControl
           End If   
    
       End If
       
    End If
End Sub



Sub FF_Control_SetFocus( ByVal hWndControl As Dword )
    
    ' Do a check to ensure that this is actually a window handle
    If IsWindow(hWndControl) Then  
       
       ' Set the focus
         SetFocus hWndControl
            
    End If
       
End Sub



Sub FF_Control_SetTag( ByVal hWnd As Dword, _
                       ByVal NewTag As String )
                    
   If IsWindow(hWnd) = 0 Then Exit Sub
    
   Local pzString  As Asciiz Ptr
   
   ' Get the pointer to the Tag string from the hWnd PROP.
   pzString = GetProp( hWnd, "FLY_TAGPROPERTY" )

   ' Free any currently allocated memory
   If pzString Then HeapFree GetProcessHeap(), 0, ByVal pzString

   If Right$(NewTag, 1) <> $Nul Then NewTag = NewTag & $Nul
   
   pzString = HeapAlloc( GetProcessHeap(), %HEAP_ZERO_MEMORY, Len(NewTag) ) 
   If pzString Then @pzString = NewTag            
   
   SetProp hWnd, "FLY_TAGPROPERTY", pzString

End Sub


Sub FF_Control_SetTag2( ByVal hWnd As Dword, _
                        ByVal NewTag As String )
                    
   If IsWindow(hWnd) = 0 Then Exit Sub
    
   Local pzString  As Asciiz Ptr
   
   ' Get the pointer to the Tag string from the hWnd PROP.
   pzString = GetProp( hWnd, "FLY_TAGPROPERTY2" )

   ' Free any currently allocated memory
   If pzString Then HeapFree GetProcessHeap(), 0, ByVal pzString

   If Right$(NewTag, 1) <> $Nul Then NewTag = NewTag & $Nul
   
   pzString = HeapAlloc( GetProcessHeap(), %HEAP_ZERO_MEMORY, Len(NewTag) ) 
   If pzString Then @pzString = NewTag            
   
   SetProp hWnd, "FLY_TAGPROPERTY2", pzString

End Sub



Sub FF_CloseForm( ByVal hwndForm As Dword, _
                  Optional ByVal ReturnValue As Long ) 
    
    If IsWindow( hWndForm ) = %FALSE Then Exit Sub
    
    Local hWndParent As Dword

    Local ff As FLY_DATA Ptr 
    ff = GetProp(hwndForm, "FLY_PTR")

    If ff Then
      If @ff.IsModal Then  
         ' Reset the focus back to the parent of the modal form.
         ' Enable Mouse and keyboard input for the Parent Form 
         hWndParent = GetWindowLong( hWndForm, %GWL_HWNDPARENT )
         If IsWindow(hWndParent) Then
            EnableWindow hWndParent, %TRUE
            SetActiveWindow hWndParent
         End If   
      End If                
    End If
    
    'Destroy the window. This will delete any font objects and release
    'the memory held by the type structure.
    DestroyWindow hWndForm 
    
    'Set the value that will be returned to the calling program.
    App.ReturnValue = ReturnValue
End Sub        



Function FF_GetFontInfo( ByVal sCurValue  As String, _
                         ByRef sFontName  As String, _
                         ByRef nPointSize As Long, _
                         ByRef nWeight    As Long, _
                         ByRef nItalic    As Long, _
                         ByRef nUnderline As Long, _
                         ByRef nStrikeOut As Long, _
                         ByRef nFontStyle As Long _
                         ) As Long
                         
  ' FireFly handles two types of font strings. The first is the traditional
  ' logfont string and the second is the simplified PB version. FireFly is moving
  ' towards the simplified version but needs to handle the logfont version
  ' for backwards compatibility.

  If ParseCount(sCurValue) > 10 Then
     ' This must be the old style logfont structure
     ' "Tahoma,-11,0,0,0,400,0,0,0,0,3,2,1,34"        ' 400 = normal, 700 = bold
     sFontName  = Parse$(sCurValue, ",", 1)
     nPointSize = AfxGetFontPointSize(Val(Parse$(sCurValue, ",", 2)))
     nWeight    = Val(Parse$(sCurValue, ",", 6))
     nItalic    = Val(Parse$(sCurValue, ",", 7)) 
     nUnderline = Val(Parse$(sCurValue, ",", 8))
     nStrikeOut = Val(Parse$(sCurValue, ",", 9)) 
     If nWeight = %FW_BOLD Then nFontStyle = nFontStyle + 1   ' normal/bold
     If IsTrue(nItalic)    Then nFontStyle = nFontStyle + 2   ' italic
     If IsTrue(nUnderline) Then nFontStyle = nFontStyle + 4   ' underline
     If IsTrue(nStrikeOut) Then nFontStyle = nFontStyle + 8   ' strikeout
  Else
     ' This is the new style (3 parts)
     sFontName  = Parse$(sCurValue, ",", 1)
     nPointSize = Val(Parse$(sCurValue, ",", 2))
     nFontStyle = Val(Parse$(sCurValue, ",", 3))
     nWeight = %FW_NORMAL
     If (nFontStyle And 1) Then nWeight = %FW_BOLD 
     If (nFontStyle And 2) Then nItalic = %TRUE
     If (nFontStyle And 4) Then nUnderline = %TRUE
     If (nFontStyle And 8) Then nStrikeOut = %TRUE
  End If
     
End Function


Function FF_EnumCharSet( _
                       elf            As ENUMLOGFONT,   _
                       ntm            As NEWTEXTMETRIC, _
                       ByVal FontType As Long, _
                       CharSet        As Long  _
                       ) As Long
                       
    CharSet = elf.elfLogFont.lfCharSet 
    Function = %TRUE
End Function


Function FF_MakeFontEX( ByVal sFont      As String, _
                        ByVal PointSize  As Long,   _
                        ByVal fBold      As Long,   _ 
                        ByVal fItalic    As Long,   _
                        ByVal fUnderline As Long,   _
                        ByVal StrikeThru As Long    _
                        ) As Dword

    Local hDC      As Long
    Local CharSet  As Long

    ' Create a high dpi aware font
    If Len(sFont) = 0 Then Exit Function

    hDC = GetDC(%HWND_DESKTOP)
    EnumFontFamilies hDC, ByVal StrPtr(sFont), CodePtr(FF_EnumCharSet), ByVal VarPtr(CharSet)
    ReleaseDC %HWND_DESKTOP, hDC
    
    Local pWindow As iWindow
    pWindow = Class "cWindow"
    pWindow.DPI = -1   ' force to get the current DPI setting
    Function = pWindow.CreateFont( sFont, PointSize, fBold, fItalic, fUnderline, StrikeThru, CharSet)
    pWindow = Nothing
    
End Function               



Function FF_MakeFontEx_Internal( ByVal sFont As String ) As Dword

   Local hFont      As Dword
   Local sFontName  As String
   Local nPointSize As Long
   Local nWeight    As Long
   Local nItalic    As Long
   Local nUnderline As Long
   Local nStrikeOut As Long 
   Local nFontStyle As Long 
      
   FF_GetFontInfo sFont, sFontName, nPointSize, nWeight, nItalic, nUnderline, nStrikeOut, nFontStyle 
   hFont = FF_MakeFontEx( sFontName, nPointSize, nWeight, nItalic, nUnderline, nStrikeOut )
               
   Function = hFont
   
End Function



Function FF_ListBox_InsertString( ByVal hWndControl As Dword, _
                                  ByVal nIndex As Long, _
                                  ByVal TheText As String _
                                  ) As Long
    
    ' Do a check to ensure that this is actually a window handle
    If IsWindow(hWndControl) Then  
       ' Set the text and return the position where the text was inserted.
       Function = SendMessage( hWndControl, %LB_INSERTSTRING, nIndex, ByVal StrPtr(TheText))
    Else
       Function = %LB_ERR
    End If  
    
End Function                



Sub FF_ListBox_ResetContent (ByVal hWndControl As Dword)
    
    ' Do a check to ensure that this is actually a window handle
    If IsWindow(hWndControl) Then  
       ' Set the text and return the position where the text was added.
       SendMessage hWndControl, %LB_RESETCONTENT, 0, 0
    End If  
    
End Sub



Function FF_ListView_GetColumnAlignment( ByVal hWndControl As Dword, _
                                         ByVal iPosition As Long _
                                         ) As Long

    Local tlvc As LV_COLUMN

    ' Do a check to ensure that this is actually a window handle
    If IsWindow(hWndControl) Then  
  
       tlvc.mask     = %LVCF_FMT 
       If SendMessage( hWndControl, %LVM_GETCOLUMN, iPosition, ByVal VarPtr(tlvc)) Then
          If (tlvc.fmt And %LVCFMT_RIGHT) = %LVCFMT_RIGHT Then 
              Function = %LVCFMT_RIGHT:  Exit Function
          End If
          If (tlvc.fmt And %LVCFMT_CENTER) = %LVCFMT_CENTER Then 
              Function = %LVCFMT_CENTER:  Exit Function
          End If
          If (tlvc.fmt And %LVCFMT_LEFT) = %LVCFMT_LEFT Then 
              Function = %LVCFMT_LEFT:  Exit Function
          End If
       End If   

    End If

End Function



Function FF_ListView_GetItemImage( ByVal hWndControl As Dword, _
                                   ByVal iRow As Long, _
                                   ByVal iColumn As Long _
                                   ) As Long

    Local tlv_item As LV_ITEM

    ' Do a check to ensure that this is actually a window handle
    If IsWindow(hWndControl) Then  
        tlv_item.mask       = %LVIF_IMAGE
        tlv_item.iItem      = iRow
        tlv_item.iSubItem   = iColumn 
       
       If SendMessage( hWndControl, %LVM_GETITEM, 0, ByVal VarPtr(tlv_item)) Then
          Function = tlv_item.iImage
       End If   

    End If

End Function



Function FF_ListView_GetItemlParam (ByVal hWndControl As Dword, _
                                    ByVal iRow As Long, _
                                    ByVal iColumn As Long) As Long

    Local tlv_item As LV_ITEM

    ' Do a check to ensure that this is actually a window handle
    If IsWindow(hWndControl) Then  
        tlv_item.mask       = %LVIF_PARAM
        tlv_item.iItem      = iRow
        tlv_item.iSubItem   = iColumn 
       
       If SendMessage( hWndControl, %LVM_GETITEM, 0, ByVal VarPtr(tlv_item)) Then
          Function = tlv_item.lParam
       End If   

    End If

End Function



Function FF_ListView_GetItemText( ByVal hWndControl As Dword, _
                                  ByVal iRow As Long, _
                                  ByVal iColumn As Long _
                                  ) As String

    Local tlv_item As LV_ITEM
    Local zText    As Asciiz * %MAX_PATH

    ' Do a check to ensure that this is actually a window handle
    If IsWindow(hWndControl) Then  
        tlv_item.mask       = %LVIF_TEXT
        tlv_item.iItem      = iRow
        tlv_item.iSubItem   = iColumn 
        tlv_item.pszText    = VarPtr(zText)
        tlv_item.cchTextMax = SizeOf(zText)
       
       If SendMessage( hWndControl, %LVM_GETITEM, 0, ByVal VarPtr(tlv_item)) Then
          Function = zText
       End If   

    End If

End Function



Function FF_ListView_InsertColumn( ByVal hWndControl As Dword, _
                                   ByVal iPosition As Long, _
                                   ByVal TheText As String, _
                                   Optional ByVal nAlignment As Long, _
                                   Optional ByVal nWidth As Long _
                                   ) As Long

    Local tlvc As LV_COLUMN

    ' Do a check to ensure that this is actually a window handle
    If IsWindow(hWndControl) Then  
  
       tlvc.mask     = %LVCF_FMT Or %LVCF_WIDTH Or %LVCF_TEXT Or %LVCF_SUBITEM
       tlvc.fmt      = nAlignment
       tlvc.cx       = nWidth
       tlvc.pszText  = StrPtr(TheText)
       tlvc.iSubItem = 0 
       Function = SendMessage( hWndControl, %LVM_INSERTCOLUMN, iPosition, ByVal VarPtr(tlvc))

    End If
    
End Function



Function FF_ListView_InsertItem( ByVal hWndControl As Dword, _
                                 ByVal iRow    As Long, _         
                                 ByVal iColumn As Long, _
                                 ByVal TheText As String, _
                                 Optional ByVal lParam As Long, _
                                 Optional ByVal iImage As Long _
                                 ) As Long

    Local tlv_item As LV_ITEM

    ' Do a check to ensure that this is actually a window handle
    If IsWindow(hWndControl) Then  
        tlv_item.iItem     = iRow
        tlv_item.iSubItem  = iColumn 
        tlv_item.pszText   = StrPtr(TheText)
        tlv_item.iImage    = iImage
        tlv_item.lParam    = lParam
        
        If iColumn = 0 Then
           tlv_item.mask      = %LVIF_TEXT Or %LVIF_PARAM Or %LVIF_IMAGE 
           Function = SendMessage( hWndControl, %LVM_INSERTITEM, 0, ByVal VarPtr(tlv_item))
        Else 
           tlv_item.mask      = %LVIF_TEXT Or %LVIF_IMAGE
           Function = SendMessage( hWndControl, %LVM_SETITEM, 0, ByVal VarPtr(tlv_item))
        End If
    End If

    
End Function



Function FF_ListView_SetColumnAlignment( ByVal hWndControl As Dword, _
                                         ByVal iPosition As Long, _
                                         ByVal nAlignment As Long _
                                         ) As Long

    Local tlvc As LV_COLUMN

    ' Do a check to ensure that this is actually a window handle
    If IsWindow(hWndControl) Then  
  
       tlvc.mask     = %LVCF_FMT 
       tlvc.fmt      = nAlignment
       Function = SendMessage( hWndControl, %LVM_SETCOLUMN, iPosition, ByVal VarPtr(tlvc))

    End If
    
End Function



Function FF_ListView_SetItemImage( ByVal hWndControl As Dword, _
                                   ByVal iRow As Long, _
                                   ByVal iColumn As Long, _
                                   ByVal iImage As Long _
                                   ) As Long

    Local tlv_item As LV_ITEM

    ' Do a check to ensure that this is actually a window handle
    If IsWindow(hWndControl) Then  
        tlv_item.mask       = %LVIF_IMAGE
        tlv_item.iItem      = iRow
        tlv_item.iSubItem   = iColumn 
        tlv_item.iImage     = iImage 
       
        Function = SendMessage( hWndControl, %LVM_SETITEM, 0, ByVal VarPtr(tlv_item)) 

    End If

End Function



Function FF_ListView_SetItemlParam( ByVal hWndControl As Dword, _
                                    ByVal iRow As Long, _
                                    ByVal iColumn As Long, _
                                    ByVal lParam As Long _
                                    ) As Long

    Local tlv_item As LV_ITEM

    ' Do a check to ensure that this is actually a window handle
    If IsWindow(hWndControl) Then  
        tlv_item.mask       = %LVIF_PARAM
        tlv_item.iItem      = iRow
        tlv_item.iSubItem   = iColumn 
        tlv_item.lParam     = lParam
       
        Function = SendMessage( hWndControl, %LVM_SETITEM, 0, ByVal VarPtr(tlv_item)) 

    End If

End Function



Function FF_ListView_SetItemText( ByVal hWndControl As Dword, _
                                  ByVal iRow As Long, _
                                  ByVal iColumn As Long, _
                                  ByVal TheText As String _
                                  ) As Long

    Local tlv_item As LV_ITEM

    ' Do a check to ensure that this is actually a window handle
    If IsWindow(hWndControl) Then  
        tlv_item.mask       = %LVIF_TEXT
        tlv_item.iItem      = iRow
        tlv_item.iSubItem   = iColumn 
        tlv_item.pszText    = StrPtr(TheText)
        tlv_item.cchTextMax = Len(TheText)
       
        Function = SendMessage( hWndControl, %LVM_SETITEM, 0, ByVal VarPtr(tlv_item)) 

    End If

End Function



Function FF_ListView_SetSelectedItem( ByVal hWndControl As Dword, _
                                      ByVal nIndex As Long _
                                      ) As Long

    ' Do a check to ensure that this is actually a window handle
    If IsWindow(hWndControl) Then  
       Function = SendMessage( hWndControl, %LVM_SETSELECTIONMARK, 0, nIndex)

       'ensure that the item is set visually as well
       Local tItem As LVITEM
       tItem.mask      = %LVIF_STATE
       tItem.iItem     = nIndex
       tItem.iSubItem  = 0
       tItem.State     = %LVIS_FOCUSED Or %LVIS_SELECTED
       tItem.statemask = %LVIS_FOCUSED Or %LVIS_SELECTED 
       SendMessage hWndControl, %LVM_SETITEMSTATE, nIndex, VarPtr(tItem)
    End If  

End Function



Type FF_RichEditSetTextParmType
   dwAddr  As Dword
   cch     As Long
   Offset  As Long
End Type


Function FF_RichEdit_SetText( ByVal hRichEdit  As Long, _
                              ByVal sBuffer    As String, _
                              ByVal fPlainText As Long _
                              ) As Long
   
   Local eStream As EDITSTREAM
   Local Parm    As FF_RichEditSetTextParmType

   Parm.dwAddr         = StrPtr(sBuffer)    ' address of NTS
   parm.cch            = Len(sBuffer)       ' Total LEN of data to be sent to control
   Parm.Offset         =  0                 ' how much as been sent so far from callback

   eStream.dwCookie    = VarPtr (Parm)       ' address so we can update in callback
   eStream.pfnCallback = CodePtr(FF_RichEditStreamSetCallback)
   eStream.dwError     = 0
   If fPlainText Then
      SendMessage hRichEdit, %EM_STREAMIN, %SF_TEXT, VarPtr(eStream)
   Else
      SendMessage hRichEdit, %EM_STREAMIN, %SF_RTF, VarPtr(eStream)
   End If   
   '- The text box is dirty now ...
   SendMessage hRichEdit, %EM_SETMODIFY, 1, 0

   Function = %True

End Function



Function FF_RichEditStreamSetCallback( ByRef Parm     As FF_RichEditSetTextParmType, _
                                       ByVal pbBuffer As Dword, _
                                       ByVal cb       As Long, _
                                       ByRef pcb      As Long _
                                       ) As Dword

   ' Code from MCM (PowerBasic forums)
   
   Local dwSource As Dword, BytesLeft As Long

   BytesLeft = parm.cch - parm.offset  ' how much have we NOT sent yet?

   ' we can send cb or bytesleft, whichever is less
   pcb              =  Min(BytesLeft, cb)
   If PCB Then          ' this will be zero if we have already sent EXACTLY the length of the file!
       dwSource     =  parm.dwAddr + Parm.offset  ' start of data + what's already sent
       'Copy the memory to the directed buffer
       CopyMemory ByVal pbBuffer, ByVal dwSource, pcb  ' use BYVALs on source, dest to avoid
                                                       ' problems with conflicting Win32api.INC
       ' increment the offset for next trip
       parm.offset = parm.offset + pcb
   End If
   Function = 0
   
End Function


Function FF_TabControl_SetSelectedTab( ByVal hWndControl As Dword, ByVal dwItem As Dword ) As Long

   Function = SendMessage( hWndControl, _          '  Handle To destination control
                           %TCM_SETCURSEL, _       '  Message ID
                           dwItem, _               '  Tab Item Index to Select
                           0 )                     '  lParam = 0, not used, must be zero
End Function   



Sub FF_TabControl_SetTabFocus (ByVal hWndControl As Dword, ByVal dwItem As Dword )
   Local lResult As Long

   lResult = SendMessage( hWndControl, _          '  Handle To destination control
                          %TCM_SETCURFOCUS, _     '  Message ID
                          dwItem, _               '  Tab Item Index where focus is to be set
                          0 )                     '  lParam = 0, not used, must be zero
End Sub  



